//---------------------------------------------------------------------------
#pragma hdrstop
#include "fRawDataFile.h"
#include "stdio.h"
#include "stdlib.h"
#include "string.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
//---------------------------------------------------------------------------
void TRawDataFile::Init()
{
   if(F!=NULL)fclose(F);//Close previous open file
   F=fopen("TEMP.DAT","wb+r");
   FDataCount=0;
   FFieldCount=0;
}
//---------------------------------------------------------------------------
int TRawDataFile::CountFields(char* s)
{
   int ret=0;
   int len=strlen(s);
   char *p=new char[len+1];
   memset(p,0,len+1);
   memcpy(p,s,len);
   if(p[len]!=',')p[len++]=',';
   while(*p++!=NULL)
      if(*p==',')ret++;
   return ret;
}
//---------------------------------------------------------------------------
void TRawDataFile::Load(char* filename)
{
   FILE* fh;
   int i, RecSize, size=256;
   int *Rec;
   char *token;
   char *s=new char[size];

   Init();
   if((fh=fopen(filename,"rt"))!=NULL){
      memset(s,0,size);
      if(fgets(s,size,fh)!=NULL){
         if((FFieldCount=CountFields(s))>0){
            Rec=new int[FFieldCount];
            RecSize=sizeof(int)*FFieldCount;
            while(fgets(s,size,fh)!=NULL){
               i=0;
               token=strtok(s,",");
               memset(Rec,0,RecSize);
               while(i<FFieldCount&&token!=NULL){
                  Rec[i++]=atoi(token);
                  token=strtok(NULL,",");
               }
               fwrite(Rec,RecSize,1,F);//write to TEMP.DAT
               FDataCount++;
            }
            delete Rec;
         }
      }
      fclose(fh);
   }
}
//---------------------------------------------------------------------------
int TRawDataFile::Data(int Index, int FieldNo)
{
   int ret=0x7FFFFFFF;//Error Data
   if(F&&Index>-1&&Index<FDataCount&& \
      FieldNo>-1&&FieldNo<FFieldCount)
   {
      int FieldSize = sizeof(int);
      int RecSize = FieldSize * FFieldCount;
      fseek(F,RecSize * Index + FieldSize * FieldNo,0);
      fread(&ret,FieldSize,1,F);
   }
   return ret;
}
//---------------------------------------------------------------------------


